Index: src/Analysis/unittests/CountBondsUnitTest.cpp
===================================================================
--- src/Analysis/unittests/CountBondsUnitTest.cpp	(revision e9e86f755ec91600316ac1b266d68b3244700842)
+++ src/Analysis/unittests/CountBondsUnitTest.cpp	(revision 833b155e089160225200039831a7742be7bb1a16)
@@ -148,5 +148,5 @@
 void CountBondsTest::HydrogenBridgeBondsTest()
 {
-  double *mirror = new double[3];
+  double mirror[3];
   CPPUNIT_ASSERT(mirror != NULL && "could not create array of doubles");
   for (int i=0;i<3;i++)
@@ -161,67 +161,65 @@
   cout << "Case 1: offset of (3,0,0), hence angles are (104.5, 0, 75.5, 180) < 30." << endl;
   Translator  = Vector(3,0,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 1 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, oxygen, NULL) );
   Translator = Vector(-3,0,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
 
   cout << "Case 2: offset of (0,3,0), hence angle are (14.5, 165.5, 90) < 30 (only three, because other 90 is missing due to first H01 only fulfilling H-bond criteria)." << endl;
   Translator = Vector(0,3,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 1 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(0,-3,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
 
   cout << "Case 3: offset of (0,-3,0) and mirror, hence angle are (165.5, 90, 165.5, 90) > 30." << endl;
   Translator = Vector(0,-3,0);
-  TestMolecule1->Scale((const double ** const)&mirror);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Scale(&mirror[0]);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(0,3,0);
-  TestMolecule1->Translate(&Translator);
-  TestMolecule1->Scale((const double ** const)&mirror);
+  TestMolecule1->Translate(Translator);
+  TestMolecule1->Scale(&mirror[0]);
 
   cout << "Case 4: offset of (2,1,0), hence angle are (78, 26.6, 102, 153.4) < 30." << endl;
   Translator = Vector(2,1,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 1 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(-2,-1,0);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
 
   cout << "Case 5: offset of (0,0,3), hence angle are (90, 90, 90, 90) > 30." << endl;
   Translator = Vector(0,0,3);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(0,0,-3);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Translate(Translator);
 
   cout << "Case 6: offset of (-3,0,0) and mirror, hence angle are (75.5, 180, 104.5, 180) > 30." << endl;
   Translator = Vector(-3,0,0);
-  TestMolecule1->Scale((const double ** const)&mirror);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Scale(&mirror[0]);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(3,0,0);
-  TestMolecule1->Translate(&Translator);
-  TestMolecule1->Scale((const double ** const)&mirror);
+  TestMolecule1->Translate(Translator);
+  TestMolecule1->Scale(&mirror[0]);
 
   cout << "Case 7: offset of (3,0,0) and mirror, hence angles are (104.5, 0, 104.5, 0) < 30, but interfering hydrogens." << endl;
   Translator = Vector(3,0,0);
-  TestMolecule1->Scale((const double ** const)&mirror);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Scale(&mirror[0]);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(-3,0,0);
-  TestMolecule1->Translate(&Translator);
-  TestMolecule1->Scale((const double ** const)&mirror);
+  TestMolecule1->Translate(Translator);
+  TestMolecule1->Scale(&mirror[0]);
 
   cout << "Case 8: offset of (0,3,0), hence angle are (14.5, 90, 14.5, 90) < 30, but interfering hydrogens." << endl;
   Translator = Vector(0,3,0);
-  TestMolecule1->Scale((const double ** const)&mirror);
-  TestMolecule1->Translate(&Translator);
+  TestMolecule1->Scale(&mirror[0]);
+  TestMolecule1->Translate(Translator);
   CPPUNIT_ASSERT_EQUAL( 0 , CountHydrogenBridgeBonds(molecules, NULL, NULL) );
   Translator = Vector(0,-3,0);
-  TestMolecule1->Translate(&Translator);
-  TestMolecule1->Scale((const double ** const)&mirror);
-
-  delete[](mirror);
-};
+  TestMolecule1->Translate(Translator);
+  TestMolecule1->Scale(&mirror[0]);
+};