Index: tests/Calculations/Makefile.am
===================================================================
--- tests/Calculations/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/Calculations/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -58,5 +58,5 @@
 	$(TESTJOBMARKETSCRIPTS)
 
-max_jobs = 4
+max_jobs = 8
 
 
Index: tests/CodeChecks/Makefile.am
===================================================================
--- tests/CodeChecks/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/CodeChecks/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -22,5 +22,5 @@
 	$(TESTSCRIPTS)
 
-max_jobs = 4
+max_jobs = 8
  
 check-local: atlocal package.m4 $(TESTSUITE)
Index: tests/Examples/Makefile.am
===================================================================
--- tests/Examples/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/Examples/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -23,5 +23,5 @@
 	$(TESTSCRIPTS)
 
-max_jobs = 4
+max_jobs = 8
  
 examples: atconfig atlocal $(TESTSUITE)
Index: tests/Fragmentations/Makefile.am
===================================================================
--- tests/Fragmentations/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/Fragmentations/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -137,5 +137,5 @@
 	Fragmenting/tartaric_acid/testsuite-fragmenting-tartaric_acid-order6.at
 
-max_jobs = 4
+max_jobs = 8
  
 check-local: atconfig atlocal $(TESTSUITE)
Index: tests/GuiChecks/Makefile.am
===================================================================
--- tests/GuiChecks/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/GuiChecks/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -216,5 +216,5 @@
 	Testlauncher/
 
-max_jobs = 4
+max_jobs = 8
  
 guicheck: adjacencymatcher atlocal package.m4 molecuilder molecuilderguitest trianglematcher $(TESTSUITE)
Index: tests/JobMarket/Makefile.am
===================================================================
--- tests/JobMarket/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/JobMarket/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -37,5 +37,5 @@
 
 if CONDJOBMARKET
-max_jobs = 4
+max_jobs = 8
  
 check-local: atconfig atlocal $(TESTSUITE)
Index: tests/Python/Makefile.am
===================================================================
--- tests/Python/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/Python/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -27,5 +27,5 @@
 	$(srcdir)/ReturnValueActions/testsuite-python-returnvalueactions.at
 
-max_jobs = 4
+max_jobs = 8
  
 check-local: atconfig atlocal $(TESTSUITE)
Index: tests/Tesselations/Makefile.am
===================================================================
--- tests/Tesselations/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/Tesselations/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -76,5 +76,5 @@
 
 
-max_jobs = 4
+max_jobs = 8
  
 check-local: atconfig atlocal molecuilder trianglematcher $(TESTSUITE)
Index: tests/integration/Makefile.am
===================================================================
--- tests/integration/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/integration/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -27,5 +27,5 @@
 
 if CONDJOBMARKET
-max_jobs = 4
+max_jobs = 8
  
 check-local: atconfig atlocal $(TESTSUITE) $(TESTSCRIPTS)
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision 755fb1fd5052f7014a4f0b178619c62e2d2fadb0)
+++ tests/regression/Makefile.am	(revision 854a1e95caee5f13422bda353b2290247bbaee3b)
@@ -248,5 +248,5 @@
 	$(srcdir)/WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at
 
-max_jobs = 4
+max_jobs = 8
  
 check-local: adjacencymatcher atconfig atlocal molecuilder runpython trianglematcher $(TESTSUITE)