Index: src/unittests/LinkedCellUnitTest.cpp
===================================================================
--- src/unittests/LinkedCellUnitTest.cpp	(revision 893bea4f34d6843af595d33ac7763c591e64648a)
+++ src/unittests/LinkedCellUnitTest.cpp	(revision 893bea4f34d6843af595d33ac7763c591e64648a)
@@ -0,0 +1,160 @@
+/*
+ * LinkedCellUnitTest.cpp
+ *
+ *  Created on: Apr 9, 2010
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+#include <stdio.h>
+#include <cstring>
+
+#include "atom.hpp"
+#include "element.hpp"
+#include "linkedcell.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "LinkedCellUnitTest.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( LinkedCellTest );
+
+
+void LinkedCellTest::setUp()
+{
+  atom *Walker = NULL;
+
+  // init private all pointers to zero
+  TestMolecule = NULL;
+  hydrogen = NULL;
+  tafel = NULL;
+
+  // construct element
+  hydrogen = new element;
+  hydrogen->Z = 1;
+  hydrogen->CovalentRadius = 0.23;
+  strcpy(hydrogen->name, "hydrogen");
+  strcpy(hydrogen->symbol, "H");
+
+  // construct periodentafel
+  tafel = new periodentafel;
+  tafel->AddElement(hydrogen);
+
+  // construct molecule (water molecule)
+  TestMolecule = new molecule(tafel);
+  Walker = new atom();
+  Walker->type = hydrogen;
+  Walker->node->Init(0., 0., 0. );
+  TestMolecule->AddAtom(Walker);
+
+  // check that TestMolecule was correctly constructed
+  CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 1 );
+  Walker = TestMolecule->start->next;
+  CPPUNIT_ASSERT( TestMolecule->end != Walker );
+
+  // construct linked cell
+  LC = new LinkedCell (TestMolecule, 1.);
+};
+
+
+void LinkedCellTest::tearDown()
+{
+  delete(LC);
+  delete(TestMolecule);
+  // note that all the atoms are cleaned by TestMolecule
+  delete(tafel);
+  // note that element is cleaned by periodentafel
+};
+
+
+/** UnitTest for LinkedCell::GetCurrentCell().
+ */
+void LinkedCellTest::GetCurrentCellTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+/** UnitTest for LinkedCell::GetRelativeToCurrentCell().
+ */
+void LinkedCellTest::GetRelativeToCurrentCellTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::SetIndexToNode().
+ */
+void LinkedCellTest::SetIndexToNodeTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::SetIndexToVector().
+ */
+void LinkedCellTest::SetIndexToVectorTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::CheckBounds().
+ */
+void LinkedCellTest::CheckBoundsTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::GetNeighbourBounds().
+ */
+void LinkedCellTest::GetNeighbourBoundsTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::GetallNeighbours().
+ */
+void LinkedCellTest::GetallNeighboursTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+
+/** UnitTest for LinkedCell::GetPointsInsideSphere().
+ */
+void LinkedCellTest::GetPointsInsideSphereTest()
+{
+  CPPUNIT_ASSERT_EQUAL( true, true );
+};
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
+
Index: src/unittests/LinkedCellUnitTest.hpp
===================================================================
--- src/unittests/LinkedCellUnitTest.hpp	(revision 893bea4f34d6843af595d33ac7763c591e64648a)
+++ src/unittests/LinkedCellUnitTest.hpp	(revision 893bea4f34d6843af595d33ac7763c591e64648a)
@@ -0,0 +1,56 @@
+/*
+ * LinkedCellUnitTest.hpp
+ *
+ *  Created on: Apr 9, 2010
+ *      Author: heber
+ */
+
+#ifndef LINKEDCELLUNITTEST_HPP_
+#define LINKEDCELLUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+
+class element;
+class LinkedCell;
+class molecule;
+class periodentafel;
+
+/********************************************** Test classes **************************************/
+
+class LinkedCellTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( LinkedCellTest) ;
+    CPPUNIT_TEST ( GetCurrentCellTest );
+    CPPUNIT_TEST ( GetRelativeToCurrentCellTest );
+    CPPUNIT_TEST ( SetIndexToNodeTest );
+    CPPUNIT_TEST ( SetIndexToVectorTest );
+    CPPUNIT_TEST ( CheckBoundsTest );
+    CPPUNIT_TEST ( GetNeighbourBoundsTest );
+    CPPUNIT_TEST ( GetNeighbourBoundsTest );
+    CPPUNIT_TEST ( GetPointsInsideSphereTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+
+      void GetCurrentCellTest();
+      void GetRelativeToCurrentCellTest();
+      void SetIndexToNodeTest();
+      void SetIndexToVectorTest();
+      void CheckBoundsTest();
+      void GetNeighbourBoundsTest();
+      void GetallNeighboursTest();
+      void GetPointsInsideSphereTest();
+
+private:
+
+      molecule *TestMolecule;
+      element *hydrogen;
+      periodentafel *tafel;
+      LinkedCell *LC;
+};
+
+
+#endif /* LINKEDCELLUNITTEST_HPP_ */
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 734816af34f8c7429239e028a7a80e4081d008ab)
+++ src/unittests/Makefile.am	(revision 893bea4f34d6843af595d33ac7763c591e64648a)
@@ -17,4 +17,5 @@
   InfoUnitTest \
   LinearSystemOfEquationsUnitTest \
+  LinkedCellUnitTest \
   ListOfBondsUnitTest \
   LogUnitTest \
@@ -64,5 +65,8 @@
 
 LinearSystemOfEquationsUnitTest_SOURCES = linearsystemofequationsunittest.cpp linearsystemofequationsunittest.hpp
-LinearSystemOfEquationsUnitTest_LDADD = ../libgslwrapper.a ../libmolecuilder.a
+LinearSystemOfEquationsUnitTest_LDADD = ../libmolecuilder.a ../libgslwrapper.a
+
+LinkedCellUnitTest_SOURCES = LinkedCellUnitTest.cpp LinkedCellUnitTest.hpp 
+LinkedCellUnitTest_LDADD = ../libmolecuilder.a ../libgslwrapper.a
 
 ListOfBondsUnitTest_SOURCES = listofbondsunittest.cpp listofbondsunittest.hpp