Index: src/Actions/createCpp.sh
===================================================================
--- src/Actions/createCpp.sh	(revision 1fd67574a5cc6c07a5638d5d343eae3b6bbdb9bf)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#!/bin/bash
-#
-#
-
-if [ -z $1 ] ; then
-	echo "Usage: $0 <Action.cpp>"
-	exit 1
-fi
-
-DIR=`dirname $1`
-ACTION=`basename $1 | awk -F"." {'print $1'} | awk -F"Action" {'print $1'}`
-action=`echo ${ACTION}Action | tr [a-z] [A-Z]`
-CATEGORY=`dirname $1 | awk -F"/" {'print $NF'}`
-
-start=`grep -n "using namespace std" $1 | awk -F":" {'print $1'}`
-end=`grep -n "::performCall(" $1 | tail -n 1 | awk -F":" {'print $1'}`
-((end-=1))
-mv $1 $1.old
-head -n $start $1.old | grep -v "/${ACTION}Action.hpp" >$1
-cat >>$1 <<EOF
-
-#include "Actions/${CATEGORY}/${ACTION}Action.hpp"
-
-// and construct the stuff
-#include "${ACTION}Action.def"
-#include "Action_impl_pre.hpp"
-/** =========== define the function ====================== */
-EOF
-bitmore=`wc -l $1.old | awk -F" " {'print $1'}`
-bitmore=$((bitmore-end))
-tail -n $bitmore $1.old >>$1
-cat >>$1 <<EOF
-/** =========== end of function ====================== */
-EOF
-
Index: src/Actions/createHeader.sh
===================================================================
--- src/Actions/createHeader.sh	(revision 1fd67574a5cc6c07a5638d5d343eae3b6bbdb9bf)
+++ 	(revision )
@@ -1,30 +1,0 @@
-#!/bin/bash
-#
-#
-
-if [ -z $1 ] ; then
-	echo "Usage: $0 <Action.hpp>"
-	exit 1
-fi
-
-DIR=`dirname $1`
-ACTION=`basename $1 | awk -F"." {'print $1'} | awk -F"Action" {'print $1'}`
-action=`echo ${ACTION}Action | tr [a-z] [A-Z]`
-
-start=`grep -n "#define $action" ${DIR}/${ACTION}Action.hpp | awk -F":" {'print $1'}`
-end=`grep -n "#endif" ${DIR}/${ACTION}Action.hpp | tail -n 1 | awk -F":" {'print $1'}`
-((end-=1))
-mv $1 $1.old
-head -n $start $1.old >$1
-cat >>$1 <<EOF
-
-#include "Actions/Action.hpp"
-
-#include "${ACTION}Action.def"
-#include "Action_impl_header.hpp"
-
-EOF
-bitmore=`wc -l $1.old | awk -F" " {'print $1'}`
-bitmore=$((bitmore-end))
-tail -n $bitmore $1.old >>$1
-
Index: src/Actions/createdef.sh
===================================================================
--- src/Actions/createdef.sh	(revision 1fd67574a5cc6c07a5638d5d343eae3b6bbdb9bf)
+++ 	(revision )
@@ -1,89 +1,0 @@
-#!/bin/bash
-#
-#
-
-if [ -z $1 ]; then
-	echo "Usage: $0 <Action.cpp>"
-	exit 1
-fi
-
-DIR=`dirname $1`
-ACTION=`basename $1 | awk -F"." {'print $1'} | awk -F"Action" {'print $1'}`
-CATEGORY=`echo $DIR | awk -F"/" {'print $NF'} | awk -F"Action" {'print $1'}`
-PARAMTYPES="#define paramtypes"
-count=0
-liste=`grep "void ${CATEGORY}${ACTION}(" $1 | awk -F"(" {'print $2'} | awk -F")" {'print $1'} | tr \  \# | sed -e "s/#*,#*/ /g" | sed -e "s/#*=#*/=/g"`
-for paramtype in $liste; do
-	paramtype=`echo $paramtype | sed -e "s/^const#*//"`
-	ptype=`echo $paramtype | awk -F"=" {'print $1'} | rev | cut -d"#" -f2- | rev | tr -d \&\*`
-	PARAMTYPES="$PARAMTYPES ($ptype)"
-	((count+=1))
-done
-PARAMTOKENS="#define paramtokens "`grep ValueStorage::getInstance\(\).setCurrentValue $1 | awk -F"(" {'print $3'} | awk -F"," {'print "("$1")"'}`
-PARAMREFS="#define paramreferences "`grep ValueStorage::getInstance\(\).setCurrentValue $1 | awk -F"," {'print $2'} | awk -F")" {'print "("$1")"'} | tr -d \ `
-PARAMTOKENS=`echo $PARAMTOKENS | sed -e "s#\n##g"`
-PARAMREFS=`echo $PARAMREFS | sed -e "s#\n##g"`
-if [ $count == 0 ]; then
-	PARAMTYPES="#undefine paramtypes"
-	PARAMTOKENS="#undefine paramtokens"
-	PARAMREFS="#undefine paramreferences"
-fi
-STATETYPES="#define statetypes"
-STATEREFS="#define statereferences"
-rcount=1
-liste=`grep "^[[:blank:]]*${CATEGORY}${ACTION}State(" $1 | awk -F"(" {'print $2'} | awk -F")" {'print $1'} | tr \  \# | tr , \ `
-for statetype in $liste; do
-	statetype=`echo $statetype | sed -e "s/^const#*//"`
-	ptype=`echo $statetype | sed -e "s/#*\&*_/_/" | awk -F"_" {'print $1'} | tr \# \ `
-	pstate=`echo $statetype | awk -F"_" {'print $2'} | tr \# \ `
-	STATETYPES="$STATETYPES ($ptype)"
-	STATEREFS="$STATEREFS ($pstate)"
-	((rcount+=1))
-	if [ $rcount -ge $count ]; then
-		break
-	fi
-done
-if [ $rcount == 1 ]; then
-	STATETYPES="#undefine statetypes"
-	STATEREFS="#undefine statereferences"
-fi
-
-TOKEN=`grep '::NAME\[\] =' $1 | awk -F"=" {'print $2'} | tr -d \ \;`
-action=`echo ${ACTION}Action | tr [a-z] [A-Z]`
-start=`grep -n "#define $action" ${DIR}/${ACTION}Action.hpp | awk -F":" {'print $1'}`
-end=`grep -n "^void ${CATEGORY}${ACTION}(" ${DIR}/${ACTION}Action.hpp | awk -F":" {'print $1'}`
-((end-=1))
-bitmore=$((end-start))
-if [ $bitmore != 0 ]; then
-	INCLUDES=`head -n $end ${DIR}/${ACTION}Action.hpp | tail -n $bitmore | grep -v "/Action.hpp" | sed -e '/^$/d'`
-else
-	INCLUDES=""
-fi
-
-cat >${DIR}/${ACTION}Action.def <<EOF
-/*
- * ${ACTION}Action.def
- *
- *  Created on: Aug 26, 2010
- *      Author: heber
- */
-
-// all includes and forward declarations necessary for non-integral types below
-$INCLUDES
-
-// i.e. there is an integer with variable name Z that can be found in
-// ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-$PARAMTYPES
-$PARAMTOKENS
-$PARAMREFS
-
-$STATETYPES
-$STATEREFS
-
-// some defines for all the names, you may use ACTION, STATE and PARAMS
-#define CATEGORY $CATEGORY
-#define ACTIONNAME $ACTION
-#define TOKEN $TOKEN
-
-EOF