Index: tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-xYz20.xyz
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-xYz20.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-xYz20.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.00082	1.84611	5.02671
+H	8.52163	2.13043	6.71726
+H	9.80746	3.11525	5.979
+H	8.15645	4.09438	4.40925
+H	7.67726	4.3787	6.0998
+H	5.7441	3.62663	4.74123
+H	6.62788	2.14475	4.30388
+H	6.1487	2.42907	5.99442
+C	8.86174	2.60492	5.79677
+C	7.81634	3.61989	5.32974
+C	6.48881	2.90356	5.07393
Index: tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z180.xyz
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z180.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z180.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	-9.78209	-2.64589	2.64589
+H	-9.78209	-2.64589	4.42589
+H	-10.672	-3.90454	3.53589
+H	-8.53279	-4.78789	2.64589
+H	-8.53279	-4.78789	4.42589
+H	-6.39363	-3.90454	3.53589
+H	-7.28359	-2.64589	2.64589
+H	-7.28359	-2.64589	4.42589
+C	-9.78209	-3.27519	3.53589
+C	-8.53279	-4.15859	3.53589
+C	-7.28359	-3.27519	3.53589
Index: tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z360.xyz
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z360.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z360.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.78209	2.64589	2.64589
+H	9.78209	2.64589	4.42589
+H	10.672	3.90454	3.53589
+H	8.53279	4.78789	2.64589
+H	8.53279	4.78789	4.42589
+H	6.39363	3.90454	3.53589
+H	7.28359	2.64589	2.64589
+H	7.28359	2.64589	4.42589
+C	9.78209	3.27519	3.53589
+C	8.53279	4.15859	3.53589
+C	7.28359	3.27519	3.53589
Index: tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z90.xyz
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z90.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/post/test-rotated-z90.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	2.64589	-9.78209	2.64589
+H	2.64589	-9.78209	4.42589
+H	3.90454	-10.672	3.53589
+H	4.78789	-8.53279	2.64589
+H	4.78789	-8.53279	4.42589
+H	3.90454	-6.39363	3.53589
+H	2.64589	-7.28359	2.64589
+H	2.64589	-7.28359	4.42589
+C	3.27519	-9.78209	3.53589
+C	4.15859	-8.53279	3.53589
+C	3.27519	-7.28359	3.53589
Index: tests/regression/Molecules/RotateAroundOrigin/pre/test.xyz
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/pre/test.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/pre/test.xyz	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.78209	2.64589	2.64589
+H	9.78209	2.64589	4.42589
+H	10.672	3.90454	3.53589
+H	8.53279	4.78789	2.64589
+H	8.53279	4.78789	4.42589
+H	6.39363	3.90454	3.53589
+H	7.28359	2.64589	2.64589
+H	7.28359	2.64589	4.42589
+C	9.78209	3.27519	3.53589
+C	8.53279	4.15859	3.53589
+C	7.28359	3.27519	3.53589
Index: tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
+++ tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at	(revision 967b3cc1d5bcc09f04bc4e2f99bb7620de669545)
@@ -0,0 +1,18 @@
+### Rotate around origin
+
+AT_SETUP([Molecules - Rotate around origin])
+AT_KEYWORDS([Molecules])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/pre/test.xyz .], 0)
+AT_CHECK([../../molecuilder -i test.xyz  --select-all-atoms --rotate-around-origin 90. --position "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created by molecuilder.*' test.xyz ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/post/test-rotated-z90.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/pre/test.xyz .], 0)
+AT_CHECK([../../molecuilder -i test.xyz  --select-all-atoms --rotate-around-origin 180. --position "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created by molecuilder.*' test.xyz ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/post/test-rotated-z180.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/pre/test.xyz .], 0)
+AT_CHECK([../../molecuilder -i test.xyz  --select-all-atoms --rotate-around-origin 360. --position "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created by molecuilder.*' test.xyz ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/post/test-rotated-z360.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' test.xyz ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/pre/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/pre/test.xyz .], 0)
+AT_CHECK([../../molecuilder -i test.xyz  --select-all-atoms --rotate-around-origin 20. --position "1,2,1"], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created by molecuilder.*' test.xyz ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/RotateAroundOrigin/post/test-rotated-xYz20.xyz], 0, [ignore], [ignore])
+AT_CLEANUP