Index: src/Potentials/Specifics/PairPotential_LennardJones.cpp
===================================================================
--- src/Potentials/Specifics/PairPotential_LennardJones.cpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ src/Potentials/Specifics/PairPotential_LennardJones.cpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -0,0 +1,225 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2013 Frederik Heber. All rights reserved.
+ * Please see the COPYING file or "Copyright notice" in builder.cpp for details.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>. 
+ */
+
+/*
+ * PairPotential_LennardJones.cpp
+ *
+ *  Created on: Jul 05, 2013
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "PairPotential_LennardJones.hpp"
+
+#include <boost/assign/list_of.hpp> // for 'map_list_of()'
+#include <boost/bind.hpp>
+#include <boost/lambda/lambda.hpp>
+#include <cmath>
+#include <string>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "FunctionApproximation/Extractors.hpp"
+#include "FunctionApproximation/TrainingData.hpp"
+#include "Potentials/helpers.hpp"
+#include "Potentials/ParticleTypeCheckers.hpp"
+
+class Fragment;
+
+// static definitions
+const PairPotential_LennardJones::ParameterNames_t
+PairPotential_LennardJones::ParameterNames =
+      boost::assign::list_of<std::string>
+      ("epsilon")
+      ("sigma")
+    ;
+const std::string PairPotential_LennardJones::potential_token("lennardjones");
+
+void PairPotential_LennardJones::setDefaultParameters()
+{
+  params[epsilon] = 1e-5;
+  params[sigma] = 8.2;
+}
+
+PairPotential_LennardJones::PairPotential_LennardJones() :
+    EmpiricalPotential(),
+    params(parameters_t(MAXPARAMS, 0.))
+{
+  // have some decent defaults for parameter_derivative checking
+  setDefaultParameters();
+}
+
+PairPotential_LennardJones::PairPotential_LennardJones(
+    const ParticleTypes_t &_ParticleTypes
+    ) :
+  EmpiricalPotential(_ParticleTypes),
+  params(parameters_t(MAXPARAMS, 0.))
+{
+  // have some decent defaults for parameter_derivative checking
+  setDefaultParameters();
+}
+
+PairPotential_LennardJones::PairPotential_LennardJones(
+    const ParticleTypes_t &_ParticleTypes,
+    const double _epsilon,
+    const double _sigma
+    ) :
+  EmpiricalPotential(_ParticleTypes),
+  params(parameters_t(MAXPARAMS, 0.))
+{
+  params[epsilon] = _epsilon;
+  params[sigma] = _sigma;
+}
+
+void PairPotential_LennardJones::setParameters(const parameters_t &_params)
+{
+  const size_t paramsDim = _params.size();
+  ASSERT( paramsDim <= getParameterDimension(),
+      "PairPotential_LennardJones::setParameters() - we need not more than "
+      +toString(getParameterDimension())+" parameters.");
+  for(size_t i=0;i<paramsDim;++i)
+    params[i] = _params[i];
+
+#ifndef NDEBUG
+  parameters_t check_params(getParameters());
+  check_params.resize(paramsDim); // truncate to same size
+  ASSERT( check_params == _params,
+      "PairPotential_LennardJones::setParameters() - failed, mismatch in to be set "
+      +toString(_params)+" and set "+toString(check_params)+" params.");
+#endif
+}
+
+PairPotential_LennardJones::results_t
+PairPotential_LennardJones::operator()(
+    const arguments_t &arguments
+    ) const
+{
+  ASSERT( arguments.size() == 1,
+      "PairPotential_LennardJones::operator() - requires one argument.");
+  ASSERT( ParticleTypeChecker::checkArgumentsAgainstParticleTypes(
+      arguments, getParticleTypes()),
+      "PairPotential_LennardJones::operator() - types don't match with ones in arguments.");
+  const double &r = arguments[0].distance;
+  const double temp = Helpers::pow(params[sigma]/r, 6);
+  const result_t result = 4.*params[epsilon] * (temp*temp - temp);
+  return std::vector<result_t>(1, result);
+}
+
+PairPotential_LennardJones::derivative_components_t
+PairPotential_LennardJones::derivative(
+    const arguments_t &arguments
+    ) const
+{
+  ASSERT( arguments.size() == 1,
+      "PairPotential_LennardJones::operator() - requires no argument.");
+  ASSERT( ParticleTypeChecker::checkArgumentsAgainstParticleTypes(
+      arguments, getParticleTypes()),
+      "PairPotential_LennardJones::operator() - types don't match with ones in arguments.");
+  const double &r = arguments[0].distance;
+  const double sigma6 = Helpers::pow(params[sigma], 6);
+  const result_t result =
+      4.*params[epsilon] * (
+          sigma6*sigma6*(-12.) / Helpers::pow(r,13)
+          - sigma6*(-6.) /Helpers::pow(r,7)
+      );
+  derivative_components_t results(1, result);
+  return results;
+}
+
+PairPotential_LennardJones::results_t
+PairPotential_LennardJones::parameter_derivative(
+    const arguments_t &arguments,
+    const size_t index
+    ) const
+{
+  ASSERT( arguments.size() == 1,
+      "PairPotential_LennardJones::parameter_derivative() - requires no argument.");
+  ASSERT( ParticleTypeChecker::checkArgumentsAgainstParticleTypes(
+      arguments, getParticleTypes()),
+      "PairPotential_LennardJones::operator() - types don't match with ones in arguments.");
+  const double &r = arguments[0].distance;
+  switch (index) {
+    case epsilon:
+    {
+      const double temp = Helpers::pow(params[sigma]/r, 6);
+      const result_t result = 4. * (temp*temp - temp);
+      return std::vector<result_t>(1, result);
+      break;
+    }
+    case sigma:
+    {
+      const double r6 = Helpers::pow(r, 6);
+      const result_t result =
+          4.*params[epsilon] * (
+              12. * Helpers::pow(params[sigma],11)/(r6*r6)
+              - 6. * Helpers::pow(params[sigma],5)/r6
+          );
+      return std::vector<result_t>(1, result);
+      break;
+    }
+    default:
+      break;
+  }
+  return std::vector<result_t>(1, 0.);
+}
+
+FunctionModel::extractor_t
+PairPotential_LennardJones::getSpecificExtractor() const
+{
+  Fragment::charges_t charges;
+  charges.resize(getParticleTypes().size());
+  std::transform(getParticleTypes().begin(), getParticleTypes().end(),
+      charges.begin(), boost::lambda::_1);
+  FunctionModel::extractor_t returnfunction =
+      boost::bind(&Extractors::gatherDistancesFromFragment,
+          boost::bind(&Fragment::getPositions, _1),
+          boost::bind(&Fragment::getCharges, _1),
+          charges,
+          _2);
+  return returnfunction;
+}
+
+FunctionModel::filter_t PairPotential_LennardJones::getSpecificFilter() const
+{
+  FunctionModel::filter_t returnfunction =
+      boost::bind(&Extractors::filterArgumentsByParticleTypes,
+          _1,
+          getParticleTypes());
+  return returnfunction;
+}
+
+void
+PairPotential_LennardJones::setParametersToRandomInitialValues(
+    const TrainingData &data)
+{
+  params[PairPotential_LennardJones::epsilon] = 1e-2*rand()/(double)RAND_MAX;
+  params[PairPotential_LennardJones::sigma] = (3.+10.*rand()/(double)RAND_MAX);// 0.5;
+}
+
Index: src/Potentials/Specifics/PairPotential_LennardJones.hpp
===================================================================
--- src/Potentials/Specifics/PairPotential_LennardJones.hpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ src/Potentials/Specifics/PairPotential_LennardJones.hpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -0,0 +1,204 @@
+/*
+ * PairPotential_LennardJones.hpp
+ *
+ *  Created on: Jul 05, 2013
+ *      Author: heber
+ */
+
+#ifndef PAIRPOTENTIAL_LENNARDJONES_HPP_
+#define PAIRPOTENTIAL_LENNARDJONES_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <limits>
+
+#include "Potentials/EmpiricalPotential.hpp"
+
+class PotentialFactory;
+class TrainingData;
+
+/** This is the implementation of a constant potential to adapt to any offset
+ * in the potential energy.
+ *
+ * This evaluates \f$ k \f$.
+ *
+ */
+class PairPotential_LennardJones :
+  public EmpiricalPotential
+{
+  //!> grant unit test access to internal parts
+  friend class PairPotential_LennardJonesTest;
+  //!> grant PotentialFactory access to default cstor
+  friend class PotentialFactory;
+  // some repeated typedefs to avoid ambiguities
+  typedef FunctionModel::arguments_t arguments_t;
+  typedef FunctionModel::result_t result_t;
+  typedef FunctionModel::results_t results_t;
+  typedef EmpiricalPotential::derivative_components_t derivative_components_t;
+  typedef FunctionModel::parameters_t parameters_t;
+private:
+  /** Private default constructor.
+   *
+   * This prevents creation of potential without set ParticleTypes_t.
+   *
+   * \note PotentialFactory may use this default cstor
+   *
+   */
+  PairPotential_LennardJones();
+
+public:
+  PairPotential_LennardJones(const ParticleTypes_t &_ParticleTypes);
+  PairPotential_LennardJones(
+      const ParticleTypes_t &_ParticleTypes,
+      const double _epsilon,
+      const double _sigma
+      );
+  virtual ~PairPotential_LennardJones() {}
+
+  /** Setter for parameters as required by FunctionModel interface.
+   *
+   * \param _params given set of parameters
+   */
+  void setParameters(const parameters_t &_params);
+
+  /** Getter for parameters as required by FunctionModel interface.
+   *
+   * \return set of parameters
+   */
+  parameters_t getParameters() const
+  {
+    return params;
+  }
+
+  /** Sets the parameter randomly within the sensible range of each parameter.
+   *
+   * \param data container with training data for guesstimating range
+   */
+  void setParametersToRandomInitialValues(const TrainingData &data);
+
+  /** Getter for the number of parameters of this model function.
+   *
+   * \return number of parameters
+   */
+  size_t getParameterDimension() const
+  {
+    return 2;
+  }
+
+  /** Evaluates the harmonic potential function for the given arguments.
+   *
+   * @param arguments single distance
+   * @return value of the potential function
+   */
+  results_t operator()(const arguments_t &arguments) const;
+
+  /** Evaluates the derivative of the potential function.
+   *
+   * @param arguments single distance
+   * @return vector with derivative with respect to the input degrees of freedom
+   */
+  derivative_components_t derivative(const arguments_t &arguments) const;
+
+  /** Evaluates the derivative of the function with the given \a arguments
+   * with respect to a specific parameter indicated by \a index.
+   *
+   * \param arguments set of arguments as input variables to the function
+   * \param index derivative of which parameter
+   * \return result vector containing the derivative with respect to the given
+   *         input
+   */
+  results_t parameter_derivative(const arguments_t &arguments, const size_t index) const;
+
+  /** Return the token name of this specific potential.
+   *
+   * \return token name of the potential
+   */
+  const std::string& getToken() const
+  { return potential_token; }
+
+  /** Returns a vector of parameter names.
+   *
+   * This is required from the specific implementation
+   *
+   * \return vector of strings containing parameter names
+   */
+  const ParameterNames_t& getParameterNames() const
+  { return ParameterNames; }
+
+  /** States whether lower and upper boundaries should be used to constraint
+   * the parameter search for this function model.
+   *
+   * \return true - constraints should be used, false - else
+   */
+  bool isBoxConstraint() const {
+    return true;
+  }
+
+  /** Returns a vector which are the lower boundaries for each parameter_t
+   * of this FunctionModel.
+   *
+   * \return vector of parameter_t resembling lowest allowed values
+   */
+  parameters_t getLowerBoxConstraints() const {
+    parameters_t lowerbound(getParameterDimension(), 0.);
+    return lowerbound;
+  }
+
+  /** Returns a vector which are the upper boundaries for each parameter_t
+   * of this FunctionModel.
+   *
+   * \return vector of parameter_t resembling highest allowed values
+   */
+  parameters_t getUpperBoxConstraints() const {
+    return parameters_t(getParameterDimension(), std::numeric_limits<double>::max());
+  }
+
+  /** Returns a bound function to be used with TrainingData, extracting distances
+   * from a Fragment.
+   *
+   * \return bound function extracting distances from a fragment
+   */
+  FunctionModel::extractor_t getSpecificExtractor() const;
+
+  /** Returns a bound function to be used with TrainingData, extracting distances
+   * from a Fragment.
+   *
+   * \return bound function extracting distances from a fragment
+   */
+  FunctionModel::filter_t getSpecificFilter() const;
+
+  /** Returns the number of arguments the underlying function requires.
+   *
+   * \return number of arguments of the function
+   */
+  size_t getSpecificArgumentCount() const
+  { return 0; }
+
+  enum parameter_enum_t {
+    epsilon=0,
+    sigma=1,
+    MAXPARAMS
+  };
+
+private:
+  /** Sets some sensible default parameter values.
+   *
+   */
+  void setDefaultParameters();
+
+private:
+  //!> parameter vector with parameters as in enum parameter_enum_t
+  parameters_t params;
+
+  //!> static definitions of the parameter name for this potential
+  static const ParameterNames_t ParameterNames;
+
+  //!> static token of this potential type
+  static const std::string potential_token;
+};
+
+#endif /* PAIRPOTENTIAL_LENNARDJONES_HPP_ */
Index: src/Potentials/Specifics/PotentialTypes.def
===================================================================
--- src/Potentials/Specifics/PotentialTypes.def	(revision 51e0e3079be933cbf6a3e3dc4a527a0575e2d1fc)
+++ src/Potentials/Specifics/PotentialTypes.def	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -1,4 +1,4 @@
 //!> preprocessor sequence of all known potential types. Just add new parser here
-#define POTENTIALSEQUENCE (constant)(tersoff)(morse)(harmonic)(harmonic_angle)
+#define POTENTIALSEQUENCE (constant)(tersoff)(morse)(harmonic)(harmonic_angle)(lennardjones)
 //!> Number of enumerations calculate automatically
 #define PotentialTypes_END BOOST_PP_SEQ_SIZE(POTENTIALSEQUENCE)
Index: src/Potentials/Specifics/unittests/Makefile.am
===================================================================
--- src/Potentials/Specifics/unittests/Makefile.am	(revision 51e0e3079be933cbf6a3e3dc4a527a0575e2d1fc)
+++ src/Potentials/Specifics/unittests/Makefile.am	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -7,4 +7,5 @@
 	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.cpp \
 	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp \
+	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp \
 	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp
 
@@ -14,4 +15,5 @@
 	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.hpp \
 	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp \
+	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp \
 	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.hpp
 
@@ -21,4 +23,5 @@
 	PairPotential_AngleUnitTest \
 	PairPotential_HarmonicUnitTest \
+	PairPotential_LennardJonesUnitTest \
 	PairPotential_MorseUnitTest
 
@@ -57,4 +60,9 @@
 PairPotential_HarmonicUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
 
+PairPotential_LennardJonesUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp \
+	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp
+PairPotential_LennardJonesUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
+
 PairPotential_MorseUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
 	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp \
Index: src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -0,0 +1,180 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2013 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * PairPotential_LennardJonesUnitTest.cpp
+ *
+ *  Created on: Jul 05, 2013
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "PairPotential_LennardJonesUnitTest.hpp"
+
+#include <boost/assign.hpp>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "FunctionApproximation/FunctionArgument.hpp"
+#include "Potentials/Specifics/PairPotential_LennardJones.hpp"
+#include "Potentials/helpers.hpp"
+
+using namespace boost::assign;
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( PairPotential_LennardJonesTest );
+
+
+void PairPotential_LennardJonesTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // data is taken from gnuplot via
+  // g(x)=4*epsilon*((sigma/x)**12 - (sigma/x)**6)
+  // set table "lj.dat"
+  // set samples 10
+  // plot [1.89012:4.46595] g(x)
+  epsilon = 0.897888;
+  sigma = 1.92953;
+  input +=
+    1.89012,
+    2.17632,
+    2.46253,
+    2.74873,
+    3.03493,
+    3.32114,
+    3.60734,
+    3.89354,
+    4.17975,
+    4.46595;
+  output +=
+    0.535795,
+    -0.897154,
+    -0.638834,
+    -0.378315,
+    -0.221526,
+    -0.132813,
+    -0.0821442,
+    -0.0524131,
+    -0.0344245,
+    -0.0232099;
+
+  CPPUNIT_ASSERT_EQUAL( input.size(), output.size() );
+}
+
+
+void PairPotential_LennardJonesTest::tearDown()
+{
+}
+
+/** UnitTest for operator()
+ */
+void PairPotential_LennardJonesTest::operatorTest()
+{
+  PairPotential_LennardJones::ParticleTypes_t types =
+      boost::assign::list_of<PairPotential_LennardJones::ParticleType_t>
+        (0)(1)
+      ;
+  PairPotential_LennardJones lj(types, epsilon, sigma);
+  for (size_t index = 0; index < input.size(); ++index) {
+    argument_t arg(argument_t::indices_t(0,1), argument_t::types_t(0,1), input[index]);
+    CPPUNIT_ASSERT(
+        Helpers::isEqual(
+            output[index],
+            lj( FunctionModel::arguments_t(1,arg) )[0],
+            1.e-4/std::numeric_limits<double>::epsilon() // only compare four digits
+        )
+    );
+  }
+}
+
+/** UnitTest for derivative()
+ */
+void PairPotential_LennardJonesTest::derivativeTest()
+{
+  PairPotential_LennardJones::ParticleTypes_t types =
+      boost::assign::list_of<PairPotential_LennardJones::ParticleType_t>
+        (0)(1)
+      ;
+  PairPotential_LennardJones lj(types, epsilon, sigma);
+  argument_t arg(argument_t::indices_t(0,1), argument_t::types_t(0,1), pow(2,1./6.)*sigma);
+  // check for zero derivative at minimum
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          lj.derivative(
+              FunctionModel::arguments_t(1,arg)
+          )[0],
+          1.e+6
+      )
+  );
+}
+
+
+/** UnitTest for parameter_derivative()
+ */
+void PairPotential_LennardJonesTest::parameter_derivativeTest()
+{
+  PairPotential_LennardJones::ParticleTypes_t types =
+      boost::assign::list_of<PairPotential_LennardJones::ParticleType_t>
+        (0)(1)
+      ;
+  PairPotential_LennardJones lj(types, epsilon, sigma);
+  argument_t arg(argument_t::indices_t(0,1), argument_t::types_t(0,1), pow(2,1./6.)*sigma);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          -1.,
+          lj.parameter_derivative(
+              FunctionModel::arguments_t(1,arg),
+              0
+          )[0],
+          1.e+6
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          lj.parameter_derivative(
+              FunctionModel::arguments_t(1,arg),
+              1
+          )[0],
+          1.e+6
+      )
+  );
+}
Index: src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ src/Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
@@ -0,0 +1,45 @@
+/*
+ * PairPotential_LennardJonesUnitTest.hpp
+ *
+ *  Created on: Jul 05, 2013
+ *      Author: heber
+ */
+
+#ifndef PAIRPOTENTIAL_LENNARDJONESUNITTEST_HPP_
+#define PAIRPOTENTIAL_LENNARDJONESUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <vector>
+
+#include <cppunit/extensions/HelperMacros.h>
+
+/********************************************** Test classes **************************************/
+
+class PairPotential_LennardJonesTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( PairPotential_LennardJonesTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST ( derivativeTest );
+    CPPUNIT_TEST ( parameter_derivativeTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+      void derivativeTest();
+      void parameter_derivativeTest();
+
+
+private:
+      typedef std::vector<double> data_t;
+      data_t input;
+      data_t output;
+      double epsilon, sigma;
+};
+
+#endif /* PAIRPOTENTIAL_LENNARDJONESUNITTEST_HPP_ */